module Pagseguro
  module Charge
    class ErrorMessage
      attr_accessor :code,
                    :message,
                    :info,
                    :description,
                    :parameter_name


      def initialize
      end

      def to_json(*options)
        hash = as_json(*options)
        hash.reject! {|k,v| v.nil?}
        hash.to_json(*options)
      end

      def self.fill_from_json(data)
        return if data.nil?

        error_message = new
        error_message.info = data["info"]
        error_message.code = data["code"]
        error_message.message = data["message"]
        error_message.description = data["description"]
        error_message.parameter_name = data["parameter_name"]
        error_message
      end

      def as_json(options={})
        {
          code: @code,
          message: @message,
          info: @info,
          description: @description,
          parameter_name: @parameter_name
        }
      end

    end

  end
end