module Pagseguro
  module Charge
    class PaymentResponse

      attr_accessor :code,
                    :message,
                    :reference

      def initialize
      end

      def to_json(*options)
        hash = as_json(*options)
        hash.reject! {|k,v| v.nil?}
        hash.to_json(*options)
      end

      def self.fill_from_json(data)
        return if data.nil?

        payment_response = new

        payment_response.code = data["code"]
        payment_response.message = data["message"]
        payment_response.reference = data["reference"]
        payment_response
      end


      def as_json(options={})
        {
          code: @code,
          message: @message,
          reference: @reference
        }
      end
    end


  end
end
